//#include<stdio.h>
//#include <stdlib.h>
#include <sstream>
#include <Magick++.h>
#include <iostream>

using namespace std;
using namespace Magick;


int round(double a) {
	return int(a + 0.5);
}

//int main(int argc,char **argv)
int main()
{
	int simsteps = 560;
	string imagefolderpath = "/home/t/Desktop/blendFiles/cache_dynamicpaint/";
	string initimagefile = "paintmap0001.png";
	//string initimagefile = "paintmap0080.png";

	string imgname ( initimagefile.begin(), initimagefile.end()-8 );
	string imgnumstr ( initimagefile.end()-8, initimagefile.end()-4 );
	string imgtype ( initimagefile.end()-4, initimagefile.end() );


	cout << "------------GO!!!--------------" << endl;

	cout << ":initfile:" << initimagefile << endl;	
	//cout << ":name:" << imgname << ":num:" << 
	//	imgnumstr << ":type:" << imgtype << endl;

	int imgnum = atoi( imgnumstr.c_str() );
	//cout << ":imgint:" << imgnum << endl;
	
	//---Construct the input image object.
	Image image;

    //---Read initial state image into object and save first frame into output files
    image.read( imagefolderpath + initimagefile );
	image.write( imagefolderpath + "clife/" + initimagefile );

    //---Get image dimensions
	unsigned int xT, yT;
	xT = image.columns();
	yT = image.rows();
	cout << "DIMS:X/Y:" << xT << "/" << yT << endl;
	
	//---Create output file of same dimensions
	Image imageout( Geometry(xT,yT), "black" );

	//---Create Dynamic Paint Image Object
	Image imageDPaint;

	//---Loop through files
	int iter = 0;
	for ( iter = 0; iter <= simsteps; iter++ )
	{
		cout << ":::RUNNING SIMSTEP:" << iter << " of " << simsteps << endl;
		
		//---Output file string to int 
		int outputfilenum = imgnum + iter + 1;
		int numtemp = 10000 + outputfilenum;
		//cout << ":nextfilenum:" << outputfilenum << endl;

		//---Output file int to string
		string strtemp;
		ostringstream numconvert;
		numconvert << numtemp;
 		strtemp = numconvert.str();
		string outputfilenumstr ( strtemp.end()-4, strtemp.end() );
		//cout << ":nextfilenumstr:" << outputfilenumstr << endl;

		//---Format full dnymaic paint image path and output image path
		string outpath = imagefolderpath + "clife/" + imgname + outputfilenumstr + imgtype;
		string dpaintpath = imagefolderpath + imgname + outputfilenumstr + imgtype;

		//---Load Dynamic Paint image
		//cout << ":Loading DPaint image:" << dpaintpath << endl;
		imageDPaint.read(dpaintpath);

		//---Loop though all pixels
		int px = 0;
		int py = 0;
		for ( py = 0; py <= yT-1; py++ )
		{
			for ( px = 0; px <= xT-1; px++ )
			{	
				//---Check for living neighbors
				int neighborsAlive = 0;
				int isAlive = 0;
				int nc0, nc1, nc2, nc3, nc4, nc5, nc6, nc7 = 0;

				ColorRGB n0(image.pixelColor( (px-1)%xT, (py-1)%yT ));
				ColorRGB n1(image.pixelColor( (px-1)%xT, py ));
				ColorRGB n2(image.pixelColor( (px-1)%xT, (py+1)%yT ));
				ColorRGB n3(image.pixelColor( px, (py-1)%yT ));
				ColorRGB n4(image.pixelColor( px, (py+1)%yT ));
				ColorRGB n5(image.pixelColor( (px+1)%xT, (py-1)%yT ));
				ColorRGB n6(image.pixelColor( (px+1)%xT, py ));
				ColorRGB n7(image.pixelColor( (px+1)%xT, (py+1)%yT ));

				nc0 = round( n0.red() );
				nc1 = round( n1.red() );
				nc2 = round( n2.red() );
				nc3 = round( n3.red() );
				nc4 = round( n4.red() );
				nc5 = round( n5.red() );
				nc6 = round( n6.red() );
				nc7 = round( n7.red() );

				neighborsAlive += nc0 + nc1 + nc2 + nc3 + nc4 + nc5 + nc6 + nc7;
		
				ColorRGB rgb(image.pixelColor(px, py));	
				isAlive = round( rgb.red() );


				//>>>>>>>>>>>> Conways Rules <<<<<<<<<<<<<
				int PMIN = 2;
				int PMAX = 3;
				int AliveNext = 0;

				if (isAlive == 1 and neighborsAlive < PMIN) {
					AliveNext = 0; //death by underpopulation
				}
				if (isAlive == 1 and neighborsAlive >= PMIN and neighborsAlive <= PMAX) {
					AliveNext = 1; //lives on
				}
				if (isAlive == 1 and neighborsAlive > PMAX) {
					AliveNext = 0; //death by overpopulation
				}
				if (isAlive == 0 and neighborsAlive == PMAX) {
					AliveNext = 1; //birth
				}

				//cout << "x/y:" << px << "/" << py << "-alive:" << isAlive;
				//cout << "-nAlive:" << neighborsAlive << "|ANext:" << AliveNext << endl;

				//---Set Pixel
				//if (isAlive == 1){imageout.pixelColor( px, py, "red" );}
				//if (isAlive == 0){imageout.pixelColor( px, py, "black" );}
				
				if (AliveNext == 1) { 
					imageout.pixelColor( px, py, "red" );
				}
				if (AliveNext == 0) {
					imageout.pixelColor( px, py, "black" );
				}
			}
			//cout << "x/y:" << px << py << "-alive:" << isAlive;
			//cout << "-nAlive:" << neighborsAlive << endl;
		}
	    //imageout.pixelColor( 49, 49, "red" ); 

		//---******GET RED CHANNEL FROM NEXT IMAGE FROM DPAINT
		px = 0;
		py = 0;
		int isOn = 0;
		for ( py = 0; py <= yT-1; py++ ){
			for ( px = 0; px <= xT-1; px++ ){
				ColorRGB rgbDP(imageDPaint.pixelColor(px, py));	
				isOn = round( rgbDP.red() );
				if ( isOn == 1 ) {
					imageout.pixelColor( px, py, "red" );
				}
			}
		}		


	    //---Write the output image to a file
		//cout << "Writing to file:" << outpath << endl;
   
		//outpath = "testout.jpg";
		imageout.write( outpath );
		cout << ":::FILE WRITTEN:" << outpath << endl;

		//---Use output image as input for next iteration
		image = imageout;
	}


	return 0;


}








